<script lang="ts">
import PostCard from "./PostCard.vue";

async function getPosts() {
  const response = await fetch("https://jsonplaceholder.typicode.com/posts");
  const data = await response.json();

  return data;
}

export default {
  mounted() {
    this.getAll();
  },
  data() {
    return {
      posts: ([] as any[]),
      isLoading: true,
      currentCount: 0
    };
  },
  methods: {
    async getAll() {
      const data = (await getPosts()).slice(0, 5);
      this.currentCount = 5;
      this.posts = data;
      this.isLoading = false;
    },
    async loadMore() {
      this.isLoading = true;
      const data = (await getPosts()).slice(0, this.currentCount + 1);
      this.currentCount += 1;
      this.posts = data;
      this.isLoading = false;
    }
  },
  components: { PostCard }
}
</script>

<template>
  <section class="posts">
    <p v-if="isLoading">loading...</p>
    <h1 v-if="!isLoading">Posts</h1>
    <ul v-if="!isLoading">
      <PostCard v-for="post in posts" :post="post" />
    </ul>
    <button @click="loadMore">Load more</button>
  </section>
</template>
      
<style>
@media (min-width: 1024px) {
  section.posts {
    min-height: 100vh;
    display: flex;
    align-items: center;
    gap: 20px;
    align-content: center;
  }
}
</style>      